
class Chiffre extends Facteur {
    Character c;

    Chiffre(Character c) throws NotCharacterException {
        //TODO?: remove extragenous whitespace
        if (Character.isLetterOrDigit(c)) {
            this.c = c;
        } else {
            throw new NotCharacterException(c + " is not a character type");
        }
    }

    private boolean isChiffre() {
        return Character.isDigit(c);
    }
    
    public double evaluer() throws NotDigitException {
        if(isChiffre()) {
            return Character.getNumericValue(c);
        } else {
            throw new NotDigitException(c + " is not a digit");
        }
    }
}
